// Generated by CoffeeScript 1.10.0
(function() {
  var ArgumentsValidator, ChatService, ChatServiceError, ChatServiceEvents, HooksInterface, MemoryState, Promise, RecoveryAPI, RedisState, ServerMessages, ServiceAPI, SocketIOTransport, UserCommands, _, execHook, extend, ref, uid,
    extend1 = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  ArgumentsValidator = require('./ArgumentsValidator');

  ChatServiceError = require('./ChatServiceError');

  ChatServiceEvents = require('./ChatServiceEvents');

  MemoryState = require('./MemoryState');

  Promise = require('bluebird');

  RecoveryAPI = require('./RecoveryAPI');

  RedisState = require('./RedisState');

  ServiceAPI = require('./ServiceAPI');

  SocketIOTransport = require('./SocketIOTransport');

  _ = require('lodash');

  uid = require('uid-safe');

  ref = require('./utils'), execHook = ref.execHook, extend = ref.extend;

  ServerMessages = (function() {
    function ServerMessages() {}

    ServerMessages.prototype.directMessage = function(msg) {};

    ServerMessages.prototype.directMessageEcho = function(toUser, msg) {};

    ServerMessages.prototype.disconnect = function(reason) {};

    ServerMessages.prototype.error = function(error) {};

    ServerMessages.prototype.loginConfirmed = function(userName, data) {};

    ServerMessages.prototype.loginRejected = function(error) {};

    ServerMessages.prototype.roomAccessRemoved = function(roomName) {};

    ServerMessages.prototype.roomAccessListAdded = function(roomName, listName, userNames) {};

    ServerMessages.prototype.roomAccessListRemoved = function(roomName, listName, userNames) {};

    ServerMessages.prototype.roomJoinedEcho = function(roomName, id, njoined) {};

    ServerMessages.prototype.roomLeftEcho = function(roomName, id, njoined) {};

    ServerMessages.prototype.roomMessage = function(roomName, msg) {};

    ServerMessages.prototype.roomModeChanged = function(roomName, mode) {};

    ServerMessages.prototype.roomUserJoined = function(roomName, userName) {};

    ServerMessages.prototype.roomUserLeft = function(roomName, userName) {};

    ServerMessages.prototype.socketConnectEcho = function(id, nconnected) {};

    ServerMessages.prototype.socketDisconnectEcho = function(id, nconnected) {};

    ServerMessages.prototype.systemMessage = function(data) {};

    return ServerMessages;

  })();

  UserCommands = (function() {
    function UserCommands() {}

    UserCommands.prototype.directAddToList = function(listName, userNames, cb) {};

    UserCommands.prototype.directGetAccessList = function(listName, cb) {};

    UserCommands.prototype.directGetWhitelistMode = function(cb) {};

    UserCommands.prototype.directMessage = function(toUser, msg, cb) {};

    UserCommands.prototype.directRemoveFromList = function(listName, userNames, cb) {};

    UserCommands.prototype.directSetWhitelistMode = function(mode, cb) {};

    UserCommands.prototype.disconnect = function(reason, cb) {};

    UserCommands.prototype.listOwnSockets = function(cb) {};

    UserCommands.prototype.roomAddToList = function(roomName, listName, userNames, cb) {};

    UserCommands.prototype.roomCreate = function(roomName, mode, cb) {};

    UserCommands.prototype.roomDelete = function(roomName, cb) {};

    UserCommands.prototype.roomGetAccessList = function(roomName, listName, cb) {};

    UserCommands.prototype.roomGetOwner = function(roomName, cb) {};

    UserCommands.prototype.roomGetWhitelistMode = function(roomName, cb) {};

    UserCommands.prototype.roomRecentHistory = function(roomName, cb) {};

    UserCommands.prototype.roomHistoryGet = function(roomName, id, limit, cb) {};

    UserCommands.prototype.roomHistoryInfo = function(roomName, cb) {};

    UserCommands.prototype.roomJoin = function(roomName, cb) {};

    UserCommands.prototype.roomLeave = function(roomName, cb) {};

    UserCommands.prototype.roomMessage = function(roomName, msg, cb) {};

    UserCommands.prototype.roomRemoveFromList = function(roomName, listName, userNames, cb) {};

    UserCommands.prototype.roomSetWhitelistMode = function(roomName, mode, cb) {};

    UserCommands.prototype.roomUserSeen = function(roomName, userName, cb) {};

    UserCommands.prototype.systemMessage = function(data, cb) {};

    return UserCommands;

  })();

  HooksInterface = {
    onConnect: function(server, id, cb) {},
    onStart: function(server, cb) {},
    onClose: function(server, cb) {},
    directMessagesChecker: function(msg, cb) {},
    roomMessagesChecker: function(msg, cb) {},
    _COMMAND_Before: function(execInfo, cb) {},
    _COMMAND_After: function(execInfo, cb) {}
  };

  ChatService = (function(superClass) {
    extend1(ChatService, superClass);

    extend(ChatService, ServiceAPI, RecoveryAPI);

    function ChatService(options, hooks) {
      this.options = options != null ? options : {};
      this.hooks = hooks != null ? hooks : {};
      ChatService.__super__.constructor.apply(this, arguments);
      this.setOptions();
      this.setComponents();
      this.startServer();
    }

    ChatService.prototype.validator = null;

    ChatService.prototype.transport = null;

    ChatService.prototype.io = null;

    ChatService.prototype.nsp = null;

    ChatService.prototype.redis = null;

    ChatService.prototype.clusterBus = null;

    ChatService.prototype.instanceUID = null;

    ChatService.ChatServiceError = ChatServiceError;

    ChatService.prototype.setOptions = function() {
      this.instanceUID = uid.sync(18);
      this.runningCommands = 0;
      this.closed = false;
      this.closeTimeout = this.options.closeTimeout || 15000;
      this.busAckTimeout = this.options.busAckTimeout || 5000;
      this.heartbeatRate = this.options.heartbeatRate || 10000;
      this.heartbeatTimeout = this.options.heartbeatTimeout || 30000;
      this.enableAccessListsUpdates = this.options.enableAccessListsUpdates || false;
      this.enableDirectMessages = this.options.enableDirectMessages || false;
      this.enableRoomsManagement = this.options.enableRoomsManagement || false;
      this.enableUserlistUpdates = this.options.enableUserlistUpdates || false;
      this.historyMaxGetMessages = this.options.historyMaxGetMessages;
      if (!_.isNumber(this.historyMaxGetMessages) || this.historyMaxGetMessages < 0) {
        this.historyMaxGetMessages = 100;
      }
      this.defaultHistoryLimit = this.options.defaultHistoryLimit;
      if (!_.isNumber(this.defaultHistoryLimit) || this.defaultHistoryLimit < 0) {
        this.defaultHistoryLimit = 10000;
      }
      this.port = this.options.port || 8000;
      this.useRawErrorObjects = this.options.useRawErrorObjects || false;
      this.adapterConstructor = this.options.adapter || 'memory';
      this.adapterOptions = _.castArray(this.options.adapterOptions);
      this.stateConstructor = this.options.state || 'memory';
      this.stateOptions = this.options.stateOptions || {};
      this.transportConstructor = this.options.transport || 'socket.io';
      this.transportOptions = this.options.transportOptions || {};
      this.directMessagesChecker = this.hooks.directMessagesChecker;
      return this.roomMessagesChecker = this.hooks.roomMessagesChecker;
    };

    ChatService.prototype.setComponents = function() {
      var State, Transport;
      State = (function() {
        switch (true) {
          case this.stateConstructor === 'memory':
            return MemoryState;
          case this.stateConstructor === 'redis':
            return RedisState;
          case _.isFunction(this.stateConstructor):
            return this.stateConstructor;
          default:
            throw new Error("Invalid state: " + this.stateConstructor);
        }
      }).call(this);
      Transport = (function() {
        switch (true) {
          case this.transportConstructor === 'socket.io':
            return SocketIOTransport;
          case _.isFunction(this.transportConstructor):
            return this.transportConstructor;
          default:
            throw new Error("Invalid transport: " + this.transportConstructor);
        }
      }).call(this);
      this.userCommands = new UserCommands();
      this.serverMessages = new ServerMessages();
      this.validator = new ArgumentsValidator(this);
      this.state = new State(this, this.stateOptions);
      return this.transport = new Transport(this, this.transportOptions, this.adapterConstructor, this.adapterOptions);
    };

    ChatService.prototype.startServer = function() {
      return Promise["try"]((function(_this) {
        return function() {
          if (_this.hooks.onStart) {
            return _this.clusterBus.listen().then(function() {
              return execHook(_this.hooks.onStart, _this);
            }).then(function() {
              return _this.transport.setEvents();
            });
          } else {
            return _this.transport.setEvents().then(function() {
              return _this.clusterBus.listen();
            });
          }
        };
      })(this)).then((function(_this) {
        return function() {
          _this.state.updateHeartbeat();
          _this.hbtimer = setInterval(_this.state.updateHeartbeat.bind(_this.state), _this.heartbeatRate);
          return _this.emit('ready');
        };
      })(this))["catch"]((function(_this) {
        return function(error) {
          _this.closed = true;
          return _this.transport.close().then(function() {
            return _this.state.close();
          })["finally"](function() {
            return _this.emit('closed', error);
          });
        };
      })(this));
    };

    ChatService.prototype.close = function(done) {
      var closeError;
      if (this.closed) {
        return Promise.resolve();
      }
      this.closed = true;
      clearInterval(this.hbtimer);
      closeError = null;
      return this.transport.close().then((function(_this) {
        return function() {
          return execHook(_this.hooks.onClose, _this, null);
        };
      })(this), (function(_this) {
        return function(error) {
          if (_this.hooks.onClose) {
            return execHook(_this.hooks.onClose, _this, error);
          } else {
            return Promise.reject(error);
          }
        };
      })(this))["catch"](function(error) {
        closeError = error;
        return Promise.reject(error);
      })["finally"]((function(_this) {
        return function() {
          return _this.state.close()["finally"](function() {
            return _this.emit('closed', closeError);
          });
        };
      })(this)).asCallback(done);
    };

    return ChatService;

  })(ChatServiceEvents);

  module.exports = ChatService;

}).call(this);

//# sourceMappingURL=ChatService.js.map
