// Generated by CoffeeScript 1.10.0
(function() {
  var ChatServiceError, CommandBinder, ExecInfo, Promise, _, debuglog, execHook, possiblyCallback, ref,
    slice = [].slice;

  ChatServiceError = require('./ChatServiceError');

  ExecInfo = require('./ExecInfo');

  Promise = require('bluebird');

  _ = require('lodash');

  ref = require('./utils'), debuglog = ref.debuglog, execHook = ref.execHook, possiblyCallback = ref.possiblyCallback;

  CommandBinder = {
    bindAck: function(cb) {
      var useRawErrorObjects;
      useRawErrorObjects = this.server.useRawErrorObjects;
      return function() {
        var data, error, rest;
        error = arguments[0], data = arguments[1], rest = 3 <= arguments.length ? slice.call(arguments, 2) : [];
        if (error && !(error instanceof ChatServiceError)) {
          debuglog(error);
        }
        if (error == null) {
          error = null;
        }
        if (data == null) {
          data = null;
        }
        if (!useRawErrorObjects) {
          error = error != null ? typeof error.toString === "function" ? error.toString() : void 0 : void 0;
        }
        return cb.apply(null, [error, data].concat(slice.call(rest)));
      };
    },
    commandWatcher: function(id, name) {
      this.server.runningCommands++;
      return Promise.resolve().disposer((function(_this) {
        return function() {
          _this.server.runningCommands--;
          if (_this.transport.closed && _this.server.runningCommands <= 0) {
            return _this.server.emit('commandsFinished');
          }
        };
      })(this));
    },
    makeCommand: function(name, fn) {
      var afterHook, beforeHook, ref1, ref2, self, validator;
      self = this;
      validator = this.server.validator;
      beforeHook = (ref1 = this.server.hooks) != null ? ref1[name + "Before"] : void 0;
      afterHook = (ref2 = this.server.hooks) != null ? ref2[name + "After"] : void 0;
      return (function(_this) {
        return function() {
          var ack, args, cb, execInfo, i, info;
          args = 3 <= arguments.length ? slice.call(arguments, 0, i = arguments.length - 2) : (i = 0, []), info = arguments[i++], cb = arguments[i++];
          if (info == null) {
            info = {};
          }
          if (cb) {
            ack = _this.bindAck(cb);
          }
          execInfo = new ExecInfo;
          _.assignIn(execInfo, {
            server: _this.server,
            userName: _this.userName
          });
          _.assignIn(execInfo, info);
          _.assignIn(execInfo, validator.splitArguments(name, args));
          return Promise.using(_this.commandWatcher(info.id, name), function(stop) {
            return validator.checkArguments.apply(validator, [name].concat(slice.call(execInfo.args))).then(function() {
              if (beforeHook && !execInfo.bypassHooks) {
                return execHook(beforeHook, execInfo);
              }
            }).then(function(results) {
              if (results != null ? results.length : void 0) {
                return results;
              }
              return fn.apply(self, slice.call(execInfo.args).concat([execInfo])).then(function(result) {
                return execInfo.results = [result];
              }, function(error) {
                return execInfo.error = error;
              }).then(function() {
                if (afterHook && !execInfo.bypassHooks) {
                  return execHook(afterHook, execInfo);
                }
              }).then(function(results) {
                if (results != null ? results.length : void 0) {
                  return results;
                } else if (execInfo.error) {
                  return Promise.reject(execInfo.error);
                } else {
                  return execInfo.results;
                }
              });
            });
          }).asCallback(ack, {
            spread: true
          });
        };
      })(this);
    },
    bindCommand: function(id, name, fn) {
      var cmd, info;
      cmd = this.makeCommand(name, fn);
      info = {
        id: id
      };
      return this.transport.bindHandler(id, name, function() {
        var args, cb, ref1;
        ref1 = possiblyCallback(arguments), args = ref1[0], cb = ref1[1];
        return cmd.apply(null, slice.call(args).concat([info], [cb]));
      });
    }
  };

  module.exports = CommandBinder;

}).call(this);

//# sourceMappingURL=CommandBinder.js.map
