// Generated by CoffeeScript 1.10.0
(function() {
  var ChatServiceError, DirectMessaging, DirectMessagingPermissions, Promise, extend;

  ChatServiceError = require('./ChatServiceError');

  Promise = require('bluebird');

  extend = require('./utils').extend;

  DirectMessagingPermissions = {
    checkList: function(author, listName) {
      return this.directMessagingState.checkList(listName);
    },
    checkListValues: function(author, listName, values) {
      return this.checkList(author, listName).then((function(_this) {
        return function() {
          var i, len, name;
          for (i = 0, len = values.length; i < len; i++) {
            name = values[i];
            if (name === _this.userName) {
              return Promise.reject(new ChatServiceError('notAllowed'));
            }
          }
        };
      })(this));
    },
    checkAcess: function(userName, bypassPermissions) {
      if (userName === this.userName) {
        return Promise.reject(new ChatServiceError('notAllowed'));
      }
      if (bypassPermissions) {
        return Promise.resolve();
      }
      return this.directMessagingState.hasInList('blacklist', userName).then((function(_this) {
        return function(blacklisted) {
          if (blacklisted) {
            return Promise.reject(new ChatServiceError('notAllowed'));
          }
          return _this.directMessagingState.whitelistOnlyGet().then(function(whitelistOnly) {
            if (!whitelistOnly) {
              return;
            }
            return _this.directMessagingState.hasInList('whitelist', userName).then(function(whitelisted) {
              if (!whitelisted) {
                return Promise.reject(new ChatServiceError('notAllowed'));
              }
            });
          });
        };
      })(this));
    }
  };

  DirectMessaging = (function() {
    extend(DirectMessaging, DirectMessagingPermissions);

    function DirectMessaging(server, userName1) {
      var State;
      this.server = server;
      this.userName = userName1;
      State = this.server.state.DirectMessagingState;
      this.directMessagingState = new State(this.server, this.userName);
    }

    DirectMessaging.prototype.initState = function(state) {
      return this.directMessagingState.initState(state);
    };

    DirectMessaging.prototype.removeState = function() {
      return this.directMessagingState.removeState();
    };

    DirectMessaging.prototype.message = function(author, msg, bypassPermissions) {
      return this.checkAcess(author, bypassPermissions);
    };

    DirectMessaging.prototype.getList = function(author, listName) {
      return this.checkList(author, listName).then((function(_this) {
        return function() {
          return _this.directMessagingState.getList(listName);
        };
      })(this));
    };

    DirectMessaging.prototype.addToList = function(author, listName, values) {
      return this.checkListValues(author, listName, values).then((function(_this) {
        return function() {
          return _this.directMessagingState.addToList(listName, values);
        };
      })(this));
    };

    DirectMessaging.prototype.removeFromList = function(author, listName, values) {
      return this.checkListValues(author, listName, values).then((function(_this) {
        return function() {
          return _this.directMessagingState.removeFromList(listName, values);
        };
      })(this));
    };

    DirectMessaging.prototype.getMode = function(author) {
      return this.directMessagingState.whitelistOnlyGet();
    };

    DirectMessaging.prototype.changeMode = function(author, mode) {
      return this.directMessagingState.whitelistOnlySet(mode);
    };

    return DirectMessaging;

  })();

  module.exports = DirectMessaging;

}).call(this);

//# sourceMappingURL=DirectMessaging.js.map
