// Generated by CoffeeScript 1.10.0
(function() {
  var ChatServiceError, DirectMessagingStateMemory, FastMap, FastSet, List, ListsStateMemory, MemoryState, Promise, Room, RoomStateMemory, User, UserStateMemory, _, extend, initState, lockOperations, promiseRetry, uid,
    extend1 = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  ChatServiceError = require('./ChatServiceError');

  FastMap = require('collections/fast-map');

  FastSet = require('collections/fast-set');

  List = require('collections/list');

  Promise = require('bluebird');

  Room = require('./Room');

  User = require('./User');

  _ = require('lodash');

  promiseRetry = require('promise-retry');

  uid = require('uid-safe');

  extend = require('./utils').extend;

  initState = function(state, values) {
    if (state) {
      state.clear();
      if (values) {
        return state.addEach(values);
      }
    }
  };

  lockOperations = {
    lock: function(key, val, ttl) {
      return promiseRetry({
        minTimeout: 100,
        retries: 10,
        factor: 1.5,
        randomize: true
      }, (function(_this) {
        return function(retry, n) {
          var err;
          if (_this.locks.has(key)) {
            err = new ChatServiceError('timeout');
            return retry(err);
          } else {
            _this.locks.set(key, val);
            return Promise.resolve();
          }
        };
      })(this));
    },
    unlock: function(key, val) {
      var currentVal;
      currentVal = this.locks.get(key);
      if (currentVal === val) {
        this.locks["delete"](key);
      }
      return Promise.resolve();
    }
  };

  ListsStateMemory = (function() {
    function ListsStateMemory() {}

    ListsStateMemory.prototype.checkList = function(listName) {
      var error;
      if (!this.hasList(listName)) {
        error = new ChatServiceError('noList', listName);
        return Promise.reject(error);
      } else {
        return Promise.resolve();
      }
    };

    ListsStateMemory.prototype.addToList = function(listName, elems) {
      return this.checkList(listName).then((function(_this) {
        return function() {
          _this[listName].addEach(elems);
          return Promise.resolve();
        };
      })(this));
    };

    ListsStateMemory.prototype.removeFromList = function(listName, elems) {
      return this.checkList(listName).then((function(_this) {
        return function() {
          _this[listName].deleteEach(elems);
          return Promise.resolve();
        };
      })(this));
    };

    ListsStateMemory.prototype.getList = function(listName) {
      return this.checkList(listName).then((function(_this) {
        return function() {
          var data;
          data = _this[listName].toArray();
          return Promise.resolve(data);
        };
      })(this));
    };

    ListsStateMemory.prototype.hasInList = function(listName, elem) {
      return this.checkList(listName).then((function(_this) {
        return function() {
          var data;
          data = _this[listName].has(elem);
          data = data ? true : false;
          return Promise.resolve(data);
        };
      })(this));
    };

    ListsStateMemory.prototype.whitelistOnlySet = function(mode) {
      this.whitelistOnly = mode ? true : false;
      return Promise.resolve();
    };

    ListsStateMemory.prototype.whitelistOnlyGet = function() {
      var wl;
      wl = this.whitelistOnly || false;
      return Promise.resolve(this.whitelistOnly);
    };

    return ListsStateMemory;

  })();

  RoomStateMemory = (function(superClass) {
    extend1(RoomStateMemory, superClass);

    function RoomStateMemory(server, name1) {
      this.server = server;
      this.name = name1;
      this.historyMaxGetMessages = this.server.historyMaxGetMessages;
      this.historyMaxSize = this.server.defaultHistoryLimit;
      this.whitelist = new FastSet;
      this.blacklist = new FastSet;
      this.adminlist = new FastSet;
      this.userlist = new FastSet;
      this.messagesHistory = new List;
      this.messagesTimestamps = new List;
      this.messagesIds = new List;
      this.usersseen = new FastMap;
      this.lastMessageId = 0;
      this.whitelistOnly = false;
      this.owner = null;
    }

    RoomStateMemory.prototype.initState = function(state) {
      var adminlist, blacklist, historyMaxSize, owner, whitelist, whitelistOnly;
      if (state == null) {
        state = {};
      }
      whitelist = state.whitelist, blacklist = state.blacklist, adminlist = state.adminlist, whitelistOnly = state.whitelistOnly, owner = state.owner, historyMaxSize = state.historyMaxSize;
      initState(this.whitelist, whitelist);
      initState(this.blacklist, blacklist);
      initState(this.adminlist, adminlist);
      initState(this.messagesHistory);
      initState(this.messagesTimestamps);
      initState(this.messagesIds);
      initState(this.usersseen);
      this.whitelistOnly = whitelistOnly ? true : false;
      this.owner = owner ? owner : null;
      return this.historyMaxSizeSet(historyMaxSize);
    };

    RoomStateMemory.prototype.removeState = function() {
      return Promise.resolve();
    };

    RoomStateMemory.prototype.startRemoving = function() {
      return Promise.resolve();
    };

    RoomStateMemory.prototype.hasList = function(listName) {
      return listName === 'adminlist' || listName === 'whitelist' || listName === 'blacklist' || listName === 'userlist';
    };

    RoomStateMemory.prototype.ownerGet = function() {
      return Promise.resolve(this.owner);
    };

    RoomStateMemory.prototype.ownerSet = function(owner) {
      this.owner = owner;
      return Promise.resolve();
    };

    RoomStateMemory.prototype.historyMaxSizeSet = function(historyMaxSize) {
      if (_.isNumber(historyMaxSize) && historyMaxSize >= 0) {
        this.historyMaxSize = historyMaxSize;
      }
      return Promise.resolve();
    };

    RoomStateMemory.prototype.historyInfo = function() {
      var historySize, info;
      historySize = this.messagesHistory.length;
      info = {
        historySize: historySize,
        historyMaxSize: this.historyMaxSize,
        historyMaxGetMessages: this.historyMaxGetMessages,
        lastMessageId: this.lastMessageId
      };
      return Promise.resolve(info);
    };

    RoomStateMemory.prototype.getCommonUsers = function() {
      var data, diff;
      diff = (this.userlist.difference(this.whitelist)).difference(this.adminlist);
      data = diff.toArray();
      return Promise.resolve(data);
    };

    RoomStateMemory.prototype.messageAdd = function(msg) {
      var makeResult, timestamp;
      timestamp = _.now();
      this.lastMessageId++;
      makeResult = (function(_this) {
        return function() {
          msg.timestamp = timestamp;
          msg.id = _this.lastMessageId;
          return Promise.resolve(msg);
        };
      })(this);
      if (this.historyMaxSize <= 0) {
        return makeResult();
      }
      this.messagesHistory.unshift(msg);
      this.messagesTimestamps.unshift(timestamp);
      this.messagesIds.unshift(this.lastMessageId);
      if (this.messagesHistory.length > this.historyMaxSize) {
        this.messagesHistory.pop();
        this.messagesTimestamps.pop();
        this.messagesIds.pop();
      }
      return makeResult();
    };

    RoomStateMemory.prototype.messagesGetRecent = function() {
      var data, i, ids, idx, len1, msg, msgs, obj, tss;
      msgs = this.messagesHistory.slice(0, this.historyMaxGetMessages);
      tss = this.messagesTimestamps.slice(0, this.historyMaxGetMessages);
      ids = this.messagesIds.slice(0, this.historyMaxGetMessages);
      data = [];
      for (idx = i = 0, len1 = msgs.length; i < len1; idx = ++i) {
        msg = msgs[idx];
        obj = _.cloneDeep(msg);
        obj.timestamp = tss[idx];
        obj.id = ids[idx];
        data[idx] = obj;
      }
      return Promise.resolve(data);
    };

    RoomStateMemory.prototype.messagesGet = function(id, maxMessages) {
      var data, end, i, ids, idx, lastid, len, len1, msg, msgs, nmessages, obj, start, tss;
      if (maxMessages == null) {
        maxMessages = this.historyMaxGetMessages;
      }
      if (maxMessages <= 0) {
        return Promise.resolve([]);
      }
      id = _.max([0, id]);
      nmessages = this.messagesIds.length;
      lastid = this.lastMessageId;
      id = _.min([id, lastid]);
      end = lastid - id;
      len = _.min([maxMessages, end]);
      start = _.max([0, end - len]);
      msgs = this.messagesHistory.slice(start, end);
      tss = this.messagesTimestamps.slice(start, end);
      ids = this.messagesIds.slice(start, end);
      data = [];
      for (idx = i = 0, len1 = msgs.length; i < len1; idx = ++i) {
        msg = msgs[idx];
        obj = _.cloneDeep(msg);
        msg.timestamp = tss[idx];
        msg.id = ids[idx];
        data[idx] = obj;
      }
      return Promise.resolve(msgs);
    };

    RoomStateMemory.prototype.userSeenGet = function(userName) {
      var joined, timestamp;
      joined = this.userlist.get(userName) ? true : false;
      timestamp = this.usersseen.get(userName) || null;
      return Promise.resolve({
        joined: joined,
        timestamp: timestamp
      });
    };

    RoomStateMemory.prototype.userSeenUpdate = function(userName) {
      var timestamp;
      timestamp = _.now();
      this.usersseen.set(userName, timestamp);
      return Promise.resolve();
    };

    return RoomStateMemory;

  })(ListsStateMemory);

  DirectMessagingStateMemory = (function(superClass) {
    extend1(DirectMessagingStateMemory, superClass);

    function DirectMessagingStateMemory(server, userName1) {
      this.server = server;
      this.userName = userName1;
      this.whitelistOnly;
      this.whitelist = new FastSet;
      this.blacklist = new FastSet;
    }

    DirectMessagingStateMemory.prototype.initState = function(arg) {
      var blacklist, ref, whitelist, whitelistOnly;
      ref = arg != null ? arg : {}, whitelist = ref.whitelist, blacklist = ref.blacklist, whitelistOnly = ref.whitelistOnly;
      initState(this.whitelist, whitelist);
      initState(this.blacklist, blacklist);
      this.whitelistOnly = whitelistOnly ? true : false;
      return Promise.resolve();
    };

    DirectMessagingStateMemory.prototype.removeState = function() {
      return Promise.resolve();
    };

    DirectMessagingStateMemory.prototype.hasList = function(listName) {
      return listName === 'whitelist' || listName === 'blacklist';
    };

    return DirectMessagingStateMemory;

  })(ListsStateMemory);

  UserStateMemory = (function() {
    extend(UserStateMemory, lockOperations);

    function UserStateMemory(server, userName1) {
      this.server = server;
      this.userName = userName1;
      this.socketsToRooms = new FastMap;
      this.socketsToInstances = new FastMap;
      this.roomsToSockets = new FastMap;
      this.locks = new FastMap;
      this.echoChannel = this.makeEchoChannelName(this.userName);
    }

    UserStateMemory.prototype.makeEchoChannelName = function(userName) {
      return "echo:" + userName;
    };

    UserStateMemory.prototype.addSocket = function(id, uid) {
      var nconnected, roomsset;
      roomsset = new FastSet;
      this.socketsToRooms.set(id, roomsset);
      this.socketsToInstances.set(id, uid);
      nconnected = this.socketsToRooms.length;
      return Promise.resolve(nconnected);
    };

    UserStateMemory.prototype.getAllSockets = function() {
      var sockets;
      sockets = this.socketsToRooms.keysArray();
      return Promise.resolve(sockets);
    };

    UserStateMemory.prototype.getSocketsToInstance = function() {
      var data;
      data = this.socketsToInstances.toObject();
      return Promise.resolve(data);
    };

    UserStateMemory.prototype.getRoomToSockets = function(roomName) {
      var data, socketsset;
      socketsset = this.roomsToSockets.get(roomName);
      data = (socketsset != null ? socketsset.toObject() : void 0) || {};
      return Promise.resolve(data);
    };

    UserStateMemory.prototype.getSocketsToRooms = function() {
      var i, id, len1, result, sockets, socketsset;
      result = {};
      sockets = this.socketsToRooms.keysArray();
      for (i = 0, len1 = sockets.length; i < len1; i++) {
        id = sockets[i];
        socketsset = this.socketsToRooms.get(id);
        result[id] = (socketsset != null ? socketsset.toArray() : void 0) || [];
      }
      return Promise.resolve(result);
    };

    UserStateMemory.prototype.addSocketToRoom = function(id, roomName) {
      var njoined, roomsset, socketsset;
      roomsset = this.socketsToRooms.get(id);
      socketsset = this.roomsToSockets.get(roomName);
      if (!socketsset) {
        socketsset = new FastSet;
        this.roomsToSockets.set(roomName, socketsset);
      }
      roomsset.add(roomName);
      socketsset.add(id);
      njoined = socketsset.length;
      return Promise.resolve(njoined);
    };

    UserStateMemory.prototype.removeSocketFromRoom = function(id, roomName) {
      var njoined, roomsset, socketsset;
      roomsset = this.socketsToRooms.get(id);
      socketsset = this.roomsToSockets.get(roomName);
      if (roomsset != null) {
        roomsset["delete"](roomName);
      }
      if (socketsset != null) {
        socketsset["delete"](id);
      }
      njoined = (socketsset != null ? socketsset.length : void 0) || 0;
      return Promise.resolve(njoined);
    };

    UserStateMemory.prototype.removeAllSocketsFromRoom = function(roomName) {
      var i, id, len1, removedSockets, roomsset, sockets, socketsset;
      sockets = this.socketsToRooms.keysArray();
      socketsset = this.roomsToSockets.get(roomName);
      removedSockets = (socketsset != null ? socketsset.toArray() : void 0) || [];
      for (i = 0, len1 = removedSockets.length; i < len1; i++) {
        id = removedSockets[i];
        roomsset = this.socketsToRooms.get(id);
        roomsset["delete"](roomName);
      }
      if (socketsset) {
        socketsset = socketsset.difference(sockets);
        this.roomsToSockets.set(roomName, socketsset);
      }
      return Promise.resolve(removedSockets);
    };

    UserStateMemory.prototype.removeSocket = function(id) {
      var i, idx, joinedSockets, len1, nconnected, njoined, removedRooms, roomName, rooms, roomsset, socketsset;
      rooms = this.roomsToSockets.toArray();
      roomsset = this.socketsToRooms.get(id);
      removedRooms = (roomsset != null ? roomsset.toArray() : void 0) || [];
      joinedSockets = [];
      for (idx = i = 0, len1 = removedRooms.length; i < len1; idx = ++i) {
        roomName = removedRooms[idx];
        socketsset = this.roomsToSockets.get(roomName);
        socketsset["delete"](id);
        njoined = socketsset.length;
        joinedSockets[idx] = njoined;
      }
      this.socketsToRooms["delete"](id);
      this.socketsToInstances["delete"](id);
      nconnected = this.socketsToRooms.length;
      return Promise.resolve([removedRooms, joinedSockets, nconnected]);
    };

    UserStateMemory.prototype.lockToRoom = function(roomName, ttl) {
      return uid(18).then((function(_this) {
        return function(val) {
          var start;
          start = _.now();
          return _this.lock(roomName, val, ttl).then(function() {
            return Promise.resolve().disposer(function() {
              if (start + ttl < _.now()) {
                _this.server.emit('lockTimeExceeded', val, {
                  userName: _this.userName,
                  roomName: roomName
                });
              }
              return _this.unlock(roomName, val);
            });
          });
        };
      })(this));
    };

    return UserStateMemory;

  })();

  MemoryState = (function() {
    function MemoryState(server, options) {
      this.server = server;
      this.options = options != null ? options : {};
      this.closed = false;
      this.users = new FastMap;
      this.rooms = new FastMap;
      this.sockets = new FastMap;
      this.RoomState = RoomStateMemory;
      this.UserState = UserStateMemory;
      this.DirectMessagingState = DirectMessagingStateMemory;
      this.instanceUID = this.server.instanceUID;
      this.heartbeatStamp = null;
      this.lockTTL = this.options.lockTTL || 5000;
    }

    MemoryState.prototype.close = function() {
      this.closed = true;
      return Promise.resolve();
    };

    MemoryState.prototype.getRoom = function(name, isPredicate) {
      var error, r;
      if (isPredicate == null) {
        isPredicate = false;
      }
      r = this.rooms.get(name);
      if (!r) {
        if (isPredicate) {
          return Promise.resolve(null);
        } else {
          error = new ChatServiceError('noRoom', name);
          return Promise.reject(error);
        }
      }
      return Promise.resolve(r);
    };

    MemoryState.prototype.addRoom = function(name, state) {
      var error, room;
      room = new Room(this.server, name);
      if (!this.rooms.get(name)) {
        this.rooms.set(name, room);
      } else {
        error = new ChatServiceError('roomExists', name);
        return Promise.reject(error);
      }
      if (state) {
        return room.initState(state)["return"](room);
      } else {
        return Promise.resolve(room);
      }
    };

    MemoryState.prototype.removeRoom = function(name) {
      this.rooms["delete"](name);
      return Promise.resolve();
    };

    MemoryState.prototype.addSocket = function(id, userName) {
      this.sockets.set(id, userName);
      return Promise.resolve();
    };

    MemoryState.prototype.removeSocket = function(id) {
      this.sockets["delete"](id);
      return Promise.resolve();
    };

    MemoryState.prototype.getInstanceSockets = function(uid) {
      return Promise.resolve(this.sockets.toObject());
    };

    MemoryState.prototype.updateHeartbeat = function() {
      this.heartbeatStamp = _.now();
      return Promise.resolve();
    };

    MemoryState.prototype.getInstanceHeartbeat = function(uid) {
      if (uid == null) {
        uid = this.instanceUID;
      }
      if (uid !== this.instanceUID) {
        return null;
      }
      return Promise.resolve(this.heartbeatStamp);
    };

    MemoryState.prototype.getOrAddUser = function(name, state) {
      var user;
      user = this.users.get(name);
      if (user) {
        return Promise.resolve(user);
      }
      return this.addUser(name, state);
    };

    MemoryState.prototype.getUser = function(name, isPredicate) {
      var error, user;
      if (isPredicate == null) {
        isPredicate = false;
      }
      user = this.users.get(name);
      if (!user) {
        if (isPredicate) {
          return Promise.resolve(null);
        } else {
          error = new ChatServiceError('noUser', name);
          return Promise.reject(error);
        }
      } else {
        return Promise.resolve(user);
      }
    };

    MemoryState.prototype.addUser = function(name, state) {
      var error, user;
      user = this.users.get(name);
      if (user) {
        error = new ChatServiceError('userExists', name);
        return Promise.reject(error);
      }
      user = new User(this.server, name);
      this.users.set(name, user);
      if (state) {
        return user.initState(state)["return"](user);
      } else {
        return Promise.resolve(user);
      }
    };

    MemoryState.prototype.removeUser = function(name) {
      this.users["delete"](name);
      return Promise.resolve();
    };

    return MemoryState;

  })();

  module.exports = MemoryState;

}).call(this);

//# sourceMappingURL=MemoryState.js.map
