// Generated by CoffeeScript 1.10.0
(function() {
  var ChatServiceError, Promise, ServiceAPI, User, _, checkNameSymbols, possiblyCallback, ref,
    slice = [].slice;

  Promise = require('bluebird');

  ChatServiceError = require('./ChatServiceError');

  _ = require('lodash');

  ref = require('./utils'), checkNameSymbols = ref.checkNameSymbols, possiblyCallback = ref.possiblyCallback;

  User = require('./User');

  ServiceAPI = {
    execUserCommand: function() {
      var args, cb, command, context, ref1, userName;
      context = arguments[0], command = arguments[1], args = 3 <= arguments.length ? slice.call(arguments, 2) : [];
      if (_.isObject(context)) {
        userName = context.userName;
      } else if (_.isBoolean(context)) {
        context = {
          bypassPermissions: context
        };
      } else {
        userName = context;
        context = null;
      }
      ref1 = possiblyCallback(args), args = ref1[0], cb = ref1[1];
      return Promise["try"]((function(_this) {
        return function() {
          if (userName) {
            return _this.state.getUser(userName);
          } else {
            return new User(_this);
          }
        };
      })(this)).then(function(user) {
        return user.exec.apply(user, [command, context].concat(slice.call(args)));
      }).asCallback(cb, {
        spread: true
      });
    },
    addUser: function(userName, state, cb) {
      return checkNameSymbols(userName).then((function(_this) {
        return function() {
          return _this.state.addUser(userName, state);
        };
      })(this))["return"]().asCallback(cb);
    },
    deleteUser: function(userName, cb) {
      return this.state.getUser(userName).then((function(_this) {
        return function(user) {
          return user.listOwnSockets().then(function(sockets) {
            if (sockets && _.size(sockets) > 0) {
              return Promise.reject(new ChatServiceError('userOnline', userName));
            } else {
              return Promise.all([user.removeState(), _this.state.removeUser(userName)]);
            }
          });
        };
      })(this))["return"]().asCallback(cb);
    },
    hasUser: function(userName, cb) {
      return this.state.getUser(userName, true).then(function(user) {
        if (user) {
          return true;
        } else {
          return false;
        }
      }).asCallback(cb);
    },
    userHasInList: function(userName, listName, item, cb) {
      return this.state.getUser(userName).then(function(user) {
        return user.directMessagingState.hasInList(listName, item);
      }).asCallback(cb);
    },
    hasDirectAccess: function(recipient, sender, cb) {
      return this.state.getUser(recipient).then(function(user) {
        return user.checkAcess(sender)["return"](true).catchReturn(ChatServiceError, false);
      }).asCallback(cb);
    },
    disconnectUserSockets: function(userName) {
      return this.clusterBus.emit('disconnectUserSockets', userName);
    },
    addRoom: function(roomName, state, cb) {
      return checkNameSymbols(roomName).then((function(_this) {
        return function() {
          return _this.state.addRoom(roomName, state);
        };
      })(this))["return"]().asCallback(cb);
    },
    deleteRoom: function(roomName, cb) {
      return this.execUserCommand(true, 'roomDelete', roomName)["return"]().asCallback(cb);
    },
    hasRoom: function(roomName, cb) {
      return this.state.getRoom(roomName, true).then(function(room) {
        if (room) {
          return true;
        } else {
          return false;
        }
      }).asCallback(cb);
    },
    roomHasInList: function(roomName, listName, item, cb) {
      return this.state.getRoom(roomName).then(function(room) {
        return room.roomState.hasInList(listName, item);
      }).asCallback(cb);
    },
    hasRoomAccess: function(roomName, userName, cb) {
      return this.state.getRoom(roomName).then(function(room) {
        return room.checkAcess(userName)["return"](true).catchReturn(ChatServiceError, false);
      }).asCallback(cb);
    },
    changeRoomOwner: function(roomName, owner, cb) {
      return this.state.getRoom(roomName).then(function(room) {
        return room.roomState.ownerSet(owner);
      })["return"]().asCallback(cb);
    },
    changeRoomHistoryMaxSize: function(roomName, size, cb) {
      return this.state.getRoom(roomName).then(function(room) {
        return room.roomState.historyMaxSizeSet(size);
      })["return"]().asCallback(cb);
    }
  };

  module.exports = ServiceAPI;

}).call(this);

//# sourceMappingURL=ServiceAPI.js.map
