// Generated by CoffeeScript 1.10.0
(function() {
  var ChatServiceError, ClusterBus, EventEmitter, Promise, RedisAdapter, SocketIOTransport, SocketServer, Transport, _, checkNameSymbols, debuglog, execHook, hasBinary, ref,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty,
    slice = [].slice;

  ChatServiceError = require('./ChatServiceError');

  EventEmitter = require('events').EventEmitter;

  Promise = require('bluebird');

  RedisAdapter = require('socket.io-redis');

  SocketServer = require('socket.io');

  Transport = require('./Transport');

  _ = require('lodash');

  hasBinary = require('has-binary');

  ref = require('./utils'), debuglog = ref.debuglog, execHook = ref.execHook, checkNameSymbols = ref.checkNameSymbols;

  ClusterBus = (function(superClass) {
    extend(ClusterBus, superClass);

    function ClusterBus(server, adapter1) {
      this.server = server;
      this.adapter = adapter1;
      ClusterBus.__super__.constructor.call(this);
      this.channel = 'cluster:bus';
      this.intenalEvents = ['roomLeaveSocket', 'socketRoomLeft', 'disconnectUserSockets'];
      this.types = [2, 5];
    }

    ClusterBus.prototype.listen = function() {
      return Promise.fromCallback((function(_this) {
        return function(cb) {
          return _this.adapter.add(_this.server.instanceUID, _this.channel, cb);
        };
      })(this));
    };

    ClusterBus.prototype.makeSocketRoomLeftName = function(id, roomName) {
      return "socketRoomLeft:" + id + ":" + roomName;
    };

    ClusterBus.prototype.mergeEventName = function(ev, args) {
      var id, nargs, nev, roomName;
      switch (ev) {
        case 'socketRoomLeft':
          id = args[0], roomName = args[1], nargs = 3 <= args.length ? slice.call(args, 2) : [];
          nev = this.makeSocketRoomLeftName(id, roomName);
          return [nev, nargs];
        default:
          return [ev, args];
      }
    };

    ClusterBus.prototype.emit = function() {
      var args, data, ev, opts, packet;
      ev = arguments[0], args = 2 <= arguments.length ? slice.call(arguments, 1) : [];
      data = [ev].concat(slice.call(args));
      packet = {
        type: (hasBinary(args) ? 5 : 2),
        data: data
      };
      opts = {
        rooms: [this.channel]
      };
      return this.adapter.broadcast(packet, opts, false);
    };

    ClusterBus.prototype.onPacket = function(packet) {
      var args, emit, ev, nargs, nev, ref1, ref2;
      ref1 = packet.data, ev = ref1[0], args = 2 <= ref1.length ? slice.call(ref1, 1) : [];
      emit = this.constructor.__super__.emit.bind(this);
      if (_.includes(this.intenalEvents, ev)) {
        ref2 = this.mergeEventName(ev, args), nev = ref2[0], nargs = ref2[1];
        return emit.apply(null, [nev].concat(slice.call(nargs)));
      } else {
        return emit.apply(null, [ev].concat(slice.call(args)));
      }
    };

    return ClusterBus;

  })(EventEmitter);

  SocketIOTransport = (function(superClass) {
    extend(SocketIOTransport, superClass);

    function SocketIOTransport(server, options, adapterConstructor, adapterOptions) {
      var Adapter;
      this.server = server;
      this.options = options;
      this.adapterConstructor = adapterConstructor;
      this.adapterOptions = adapterOptions;
      SocketIOTransport.__super__.constructor.apply(this, arguments);
      this.hooks = this.server.hooks;
      this.io = this.options.io;
      this.namespace = this.options.namespace || '/chat-service';
      Adapter = (function() {
        switch (true) {
          case this.adapterConstructor === 'memory':
            return null;
          case this.adapterConstructor === 'redis':
            return RedisAdapter;
          case _.isFunction(this.adapterConstructor):
            return this.adapterConstructor;
          default:
            throw new Error("Invalid transport adapter: " + this.adapterConstructor);
        }
      }).call(this);
      if (!this.io) {
        this.ioOptions = this.options.ioOptions;
        this.http = this.options.http;
        if (this.http) {
          this.dontCloseIO = true;
          this.io = new SocketServer(this.options.http);
        } else {
          this.io = new SocketServer(this.server.port, this.ioOptions);
        }
        if (Adapter) {
          this.adapter = (function(func, args, ctor) {
            ctor.prototype = func.prototype;
            var child = new ctor, result = func.apply(child, args);
            return Object(result) === result ? result : child;
          })(Adapter, this.adapterOptions, function(){});
          this.io.adapter(this.adapter);
        }
      } else {
        this.dontCloseIO = true;
      }
      this.nsp = this.io.of(this.namespace);
      this.server.io = this.io;
      this.server.nsp = this.nsp;
      this.clusterBus = new ClusterBus(this.server, this.nsp.adapter);
      this.injectBusHook();
      this.attachBusListeners();
      this.server.clusterBus = this.clusterBus;
      this.closed = false;
    }

    SocketIOTransport.prototype.broadcastHook = function(packet, opts) {
      if (_.indexOf(opts.rooms, this.clusterBus.channel) >= 0 && _.indexOf(this.clusterBus.types, packet.type) >= 0) {
        return this.clusterBus.onPacket(packet);
      }
    };

    SocketIOTransport.prototype.injectBusHook = function() {
      var adapter, broadcastHook, orig;
      broadcastHook = this.broadcastHook.bind(this);
      adapter = this.nsp.adapter;
      orig = adapter.broadcast;
      return adapter.broadcast = function() {
        var args;
        args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
        broadcastHook.apply(null, args);
        return orig.apply(adapter, args);
      };
    };

    SocketIOTransport.prototype.attachBusListeners = function() {
      this.clusterBus.on('roomLeaveSocket', (function(_this) {
        return function(id, roomName) {
          return _this.leaveChannel(id, roomName).then(function() {
            return _this.clusterBus.emit('socketRoomLeft', id, roomName);
          }).catchReturn();
        };
      })(this));
      return this.clusterBus.on('disconnectUserSockets', (function(_this) {
        return function(userName) {
          return _this.server.state.getUser(userName).then(function(user) {
            return user.disconnectInstanceSockets();
          }).catchReturn();
        };
      })(this));
    };

    SocketIOTransport.prototype.rejectLogin = function(socket, error) {
      var useRawErrorObjects;
      useRawErrorObjects = this.server.useRawErrorObjects;
      if (error && !(error instanceof ChatServiceError)) {
        debuglog(error);
      }
      if (!useRawErrorObjects) {
        error = error != null ? typeof error.toString === "function" ? error.toString() : void 0 : void 0;
      }
      socket.emit('loginRejected', error);
      return socket.disconnect();
    };

    SocketIOTransport.prototype.confirmLogin = function(socket, userName, authData) {
      authData.id = socket.id;
      socket.emit('loginConfirmed', userName, authData);
      return Promise.resolve();
    };

    SocketIOTransport.prototype.addClient = function(socket, userName, authData) {
      var id;
      if (authData == null) {
        authData = {};
      }
      id = socket.id;
      return Promise["try"](function() {
        var ref1;
        if (!userName) {
          userName = (ref1 = socket.handshake.query) != null ? ref1.user : void 0;
          if (!userName) {
            return Promise.reject(new ChatServiceError('noLogin'));
          }
        }
      }).then(function() {
        return checkNameSymbols(userName);
      }).then((function(_this) {
        return function() {
          return _this.server.state.getOrAddUser(userName);
        };
      })(this)).then(function(user) {
        return user.registerSocket(id);
      }).spread((function(_this) {
        return function(user, nconnected) {
          return _this.joinChannel(id, user.echoChannel).then(function() {
            user.socketConnectEcho(id, nconnected);
            return _this.confirmLogin(socket, userName, authData);
          });
        };
      })(this))["catch"]((function(_this) {
        return function(error) {
          return _this.rejectLogin(socket, error);
        };
      })(this));
    };

    SocketIOTransport.prototype.setEvents = function() {
      var fn, i, len, middleware;
      if (this.hooks.middleware) {
        middleware = _.castArray(this.hooks.middleware);
        for (i = 0, len = middleware.length; i < len; i++) {
          fn = middleware[i];
          this.nsp.use(fn);
        }
      }
      if (this.hooks.onConnect) {
        this.nsp.on('connection', (function(_this) {
          return function(socket) {
            return Promise["try"](function() {
              return execHook(_this.hooks.onConnect, _this.server, socket.id);
            }).then(function(loginData) {
              loginData = _.castArray(loginData);
              return _this.addClient.apply(_this, [socket].concat(slice.call(loginData)));
            })["catch"](function(error) {
              return _this.rejectLogin(socket, error);
            });
          };
        })(this));
      } else {
        this.nsp.on('connection', this.addClient.bind(this));
      }
      return Promise.resolve();
    };

    SocketIOTransport.prototype.waitCommands = function() {
      if (this.server.runningCommands > 0) {
        return Promise.fromCallback((function(_this) {
          return function(cb) {
            return _this.server.once('commandsFinished', cb);
          };
        })(this));
      }
    };

    SocketIOTransport.prototype.close = function() {
      this.closed = true;
      this.nsp.removeAllListeners('connection');
      this.clusterBus.removeAllListeners();
      return Promise["try"]((function(_this) {
        return function() {
          var id, ref1, socket;
          if (!_this.dontCloseIO) {
            _this.io.close();
          } else if (_this.http) {
            _this.io.engine.close();
          } else {
            ref1 = _this.nsp.connected;
            for (id in ref1) {
              socket = ref1[id];
              socket.disconnect();
            }
          }
        };
      })(this)).then((function(_this) {
        return function() {
          return _this.waitCommands();
        };
      })(this)).timeout(this.server.closeTimeout);
    };

    SocketIOTransport.prototype.bindHandler = function(id, name, fn) {
      var socket;
      socket = this.getConnectionObject(id);
      if (socket) {
        return socket.on(name, fn);
      }
    };

    SocketIOTransport.prototype.getConnectionObject = function(id) {
      SocketIOTransport.__super__.getConnectionObject.apply(this, arguments);
      return this.nsp.connected[id];
    };

    SocketIOTransport.prototype.emitToChannel = function() {
      var channel, messageData, messageName, ref1;
      channel = arguments[0], messageName = arguments[1], messageData = 3 <= arguments.length ? slice.call(arguments, 2) : [];
      SocketIOTransport.__super__.emitToChannel.apply(this, arguments);
      (ref1 = this.nsp.to(channel)).emit.apply(ref1, [messageName].concat(slice.call(messageData)));
    };

    SocketIOTransport.prototype.sendToChannel = function() {
      var channel, id, messageData, messageName, ref1, socket;
      id = arguments[0], channel = arguments[1], messageName = arguments[2], messageData = 4 <= arguments.length ? slice.call(arguments, 3) : [];
      SocketIOTransport.__super__.sendToChannel.apply(this, arguments);
      socket = this.getConnectionObject(id);
      if (!socket) {
        this.emitToChannel.apply(this, [channel, messageName].concat(slice.call(messageData)));
      } else {
        (ref1 = socket.to(channel)).emit.apply(ref1, [messageName].concat(slice.call(messageData)));
      }
    };

    SocketIOTransport.prototype.joinChannel = function(id, channel) {
      var socket;
      socket = this.getConnectionObject(id);
      if (!socket) {
        return Promise.reject(new ChatServiceError('invalidSocket', id));
      } else {
        return Promise.fromCallback(function(fn) {
          return socket.join(channel, fn);
        });
      }
    };

    SocketIOTransport.prototype.leaveChannel = function(id, channel) {
      var socket;
      socket = this.getConnectionObject(id);
      if (!socket) {
        return Promise.resolve();
      }
      return Promise.fromCallback(function(fn) {
        return socket.leave(channel, fn);
      });
    };

    SocketIOTransport.prototype.disconnectClient = function(id) {
      var socket;
      socket = this.getConnectionObject(id);
      if (socket) {
        socket.disconnect();
      }
      return Promise.resolve();
    };

    return SocketIOTransport;

  })(Transport);

  module.exports = SocketIOTransport;

}).call(this);

//# sourceMappingURL=SocketIOTransport.js.map
