// Generated by CoffeeScript 1.10.0
(function() {
  var ChatServiceError, Promise, _, asyncLimit, checkNameSymbols, debuglog, execHook, extend, nameChecker, possiblyCallback, util,
    slice = [].slice;

  ChatServiceError = require('./ChatServiceError');

  Promise = require('bluebird');

  _ = require('lodash');

  util = require('util');

  debuglog = util.debuglog('ChatService');

  asyncLimit = 32;

  nameChecker = /^[^\u0000-\u001F:{}\u007F]+$/;

  extend = function() {
    var c, i, len, method, mixin, mixins, name, results;
    c = arguments[0], mixins = 2 <= arguments.length ? slice.call(arguments, 1) : [];
    results = [];
    for (i = 0, len = mixins.length; i < len; i++) {
      mixin = mixins[i];
      results.push((function() {
        var results1;
        results1 = [];
        for (name in mixin) {
          method = mixin[name];
          if (!c.prototype[name]) {
            results1.push(c.prototype[name] = method);
          } else {
            results1.push(void 0);
          }
        }
        return results1;
      })());
    }
    return results;
  };

  possiblyCallback = function(args) {
    var cb;
    cb = _.last(args);
    if (_.isFunction(cb)) {
      args = _.slice(args, 0, -1);
    } else {
      cb = null;
    }
    return [args, cb];
  };

  checkNameSymbols = function(name) {
    if (_.isString(name) && nameChecker.test(name)) {
      return Promise.resolve();
    } else {
      return Promise.reject(new ChatServiceError('invalidName', name));
    }
  };

  execHook = function() {
    var args, callbackData, cb, hook, res, wrapper;
    hook = arguments[0], args = 2 <= arguments.length ? slice.call(arguments, 1) : [];
    if (!hook) {
      return Promise.resolve();
    }
    cb = null;
    callbackData = null;
    wrapper = function() {
      var data;
      data = 1 <= arguments.length ? slice.call(arguments, 0) : [];
      callbackData = data;
      if (cb) {
        return cb.apply(null, data);
      }
    };
    res = hook.apply(null, slice.call(args).concat([wrapper]));
    if (callbackData) {
      return Promise.fromCallback(function(fn) {
        return fn.apply(null, callbackData);
      }, {
        multiArgs: true
      });
    } else if (typeof (res != null ? res.then : void 0) === 'function') {
      return res;
    } else {
      return Promise.fromCallback(function(fn) {
        return cb = fn;
      }, {
        multiArgs: true
      });
    }
  };

  module.exports = {
    asyncLimit: asyncLimit,
    checkNameSymbols: checkNameSymbols,
    debuglog: debuglog,
    execHook: execHook,
    extend: extend,
    nameChecker: nameChecker,
    possiblyCallback: possiblyCallback
  };

}).call(this);

//# sourceMappingURL=utils.js.map
